#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char buf[1024];
long j;

typedef struct _tree {
  struct _tree *left, *right;
  char op;
  char var;
} tree;

void factor(tree **mt);
void expression(tree **mt);
void term(tree **mt);

void error() 
{
  printf("seltsam\n");
}

int isalpha(char c)
{
  if ((c>='a' && c<='z') || (c>='A' && c<='Z'))
    return 1;
  return 0;
}

void factor(tree **mt)
{
  if (buf[j]=='(')
  {
    j++;
    expression(mt);
    if (buf[j]==')') 
      j++;
    else
      error();
  } else
  {
    if (isalpha(buf[j]))
    {
      *mt = malloc(sizeof(tree));
      (*mt)->left = NULL;
      (*mt)->right = NULL;
      (*mt)->op = '_';
      (*mt)->var = buf[j];
      j++;
    } else
      error();
  }
}

void term(tree **mt) 
{
  tree *left, *right, *tmp;
  factor(&left);
  // factor(&(*mt)->left);
  if (buf[j] == '*' || buf[j] == '/')
  {
    if (left==NULL)
    {
      error();
    }
    *tmp = malloc(sizeof(tree));
    (*tmp)->left = NULL;
    (*tmp)->right = NULL;
    (*tmp)->op = '&';
    (*mt)->op = buf[j];
    j++;
    term(&(*mt)->right);
  }
}

void expression(tree **mt)
{
  *mt = malloc(sizeof(tree));
  (*mt)->left = NULL;
  (*mt)->right = NULL;
  (*mt)->op = '&';
  term(&(*mt)->left);
  if (buf[j]=='+' || buf[j]=='-')
  {
    (*mt)->op = buf[j];
    j++;
    expression(&(*mt)->right);
  }
}

void treepurge(tree *root)
{
  if (root->op == '&')
  {
    tree *p = root->left;
    root->op = p->op;
    root->var = p->var;
    root->left = p->left;
    root->right = p->right;
    free(p);
  }
  if (root->op != '_')
    treepurge(root->left);
  if (root->right)
    treepurge(root->right);
}

void printtree(tree *root)
{
  if (root->op == '_')
    printf("%c", root->var);
  else
  {
    printtree(root->left);
    if (root->right)
    {
      printf("%c", root->op);
      printf("(");
      printtree(root->right);
      printf(")");
    }
  }
}

int main()
{
  tree *root;
  long n, N;

  fgets(buf, 1024, stdin);
  N = strtol(buf, NULL, 10);

  for (n=0; n<N; n++)
  {
    fgets(buf, 1024, stdin);

    j=0;
    root = NULL;
    expression(&root);

    // treepurge(root);
    printtree(root);
    printf("\n");
  }

  return 0;
}
